import SocketServer
import subprocess
import os
import datetime
import codecs
import time


class MyTCPHandler(SocketServer.BaseRequestHandler):
    def handle(self):
        log = codecs.open("C:\Users\Daniel\Dropbox\Masteroppgave 2013-14\ServerOutput\serverlog.txt", 'a+', 'utf-8')
        # self.request is the TCP socket connected to the client
        log.write("---------" + str(datetime.datetime.now()) + "---------\n")
        time.sleep(1)
        self.data = self.recv_all(8192)
        log.write("Read: " + str(len(self.data)) + " bytes\n")
        log.write("{} wrote:".format(self.client_address[0])+"\n")
        log.write(self.data + "\n")
        file = open("sketch/sketch.cpp", 'w')
        file.write(self.data)
        file.close()

        #Remove old hex in case of compile fail
        try:
            os.remove("sketch/sketch.cpp.hex")
            print("Removed old file")
        except OSError:
            pass

        #Operating System
        if os.name == "posix":
            #linuxStuff
            pass
        elif os.name == "nt":
            #windows
            subprocess.call("compiler.bat", shell=True)
            print subprocess.CalledProcessError

        else:
            log.write("Only support for Linux/Windows (none detected)\n")
        log.close()

        if os.path.isfile("sketch/sketch.cpp.hex"):
            file = open("sketch/sketch.cpp.hex", 'r')
            hex = file.read();
            file.close()
            hex = hex.replace(":", "3A")
            self.request.sendall(hex)
        else:
            self.request.sendall("fail")

    def recv_all(self, readSize):
        total_data=[]
        data = self.request.recv(readSize)
        total_data.append(data)
        while len(data) == readSize:
            data = self.request.recv(readSize)
            total_data.append(data)
        return ''.join(total_data)


if __name__ == "__main__":
    HOST, PORT = "192.168.0.102", 8000

    server = SocketServer.TCPServer((HOST, PORT), MyTCPHandler)
    server.serve_forever()