/*
 * Licensed to UbiCollab.org under one or more contributor
 * license agreements.  See the NOTICE file distributed
 * with this work for additional information regarding
 * copyright ownership. UbiCollab.org licenses this file
 * to you under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance
 * with the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */

package no.ntnu.android.toolkit.bluetooth;

import android.content.Context;
import android.widget.ArrayAdapter;

public class BluetoothListAdapter extends ArrayAdapter{

    public BluetoothListAdapter(Context context, int resource, int textViewResourceId) {
        super(context, resource, textViewResourceId);
    }

    @Override
    public void add(Object object) {
        boolean exists = false;
        for(int i = 0; i< getCount(); i++){
            if(getItem(i).equals(object)){
                exists = true;
                break;
            }
        }
        if(!exists)
            super.add(object);
    }




}
